/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Platform Development Center
 *                                          RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2003-2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */

/*
 *	^[QbgVXeˑW[iQB-R5F100LEpj
 */
#pragma sfr
#pragma NOP
#include "kernel_impl.h"

/*
 *  ^[QbgVXeˑ [`
 */

void
target_initialize(void)
{
	/*
	 *  vZbTˑ̏
	 */
	prc_initialize();
	
	/*
	 * NbNݒ
	 */
	// X1M[hCUCAMPH=1(NbN)
	CMC = UINT8_C(0x51);
	
	// NbNXe[^X䃌WX^(X1JnCXT1~, I`bvIV[^)
	CSC = UINT8_C(0x40);

	// U肷܂ł̎Ԃ҂
	while((OSTC & UINT8_C(0x01)) == 0){}
	
	// VXeNbN䃌WX^
	CKC &= ~UINT8_C(0x40);	// CPU/Ӄn[hEFANbNɃCVXeNbN
	CKC |= UINT8_C(0x10);	// CVXeNbNɍVXeNbN
	CKC &= ~UINT8_C(0x0f);	// K0ɐݒ

	// NbNXe[^X䃌WX^
	CSC |= UINT8_C(0x01); 	// I`bvIV[^~

	/*
	 * UARTpsݒ
	 */
	// RXDCTXD  P11, P12 gp
	PIOR &= ~TBIT_PIOR_PIOR1;

	// P11(RxD0) ͂ɐݒ
	PM1 |= UINT8_C(0x02);

	// P12(TxD0) Hɐݒ肵Ă
	P1 |= UINT8_C(0x04);

	// P12(TxD0) o͂ɐݒ
	PM1 &= ~UINT8_C(0x04);

	/*
	 * UART̐ݒ
	 */
	target_sau_init(1);	
}


/*
 *  ^[QbgVXȅI[`
 */

void
target_exit(void)
{
	/* CPUˑ̏I[` */
	prc_terminate();
	
	while (true)
	{
	}
}

/*
 * VXeO̒჌xo͂̂߂̕o
 */
void target_fput_log(char c)
{
	if (c == '\n') {
		sys_putc('\r', LOGTASK_PORTID);
	}
	sys_putc(c, LOGTASK_PORTID);
}

/*
 *  AT[V̎s̎sf
 */
void
TOPPERS_assert_abort(void)
{
	while(1)
	{
	}
}
